# Coveo Sort Component (CoveoSort)

The `Sort` component renders a widget that the end user can interact with to select the criterion to use when sorting query results.

To improve accessibility, it's recommended to group `Sort` components in a container with `role="radiogroup"`.

## Index

### Methods

- debugInfo
- disable
- enable
- getBindings
- getCurrentCriteria
- match
- select
- selectAndExecuteQuery
- get

### Properties

- bind
- componentOptionsModel
- componentStateModel
- disabled
- logger
- queryController
- queryStateModel
- root
- searchInterface
- ID

### Accessors

- usageAnalytics

### Component Options

- caption
- sortCriteria

### Constructors

- constructor

## Methods

### debugInfo

- debugInfo(): any

- Inherited from BaseComponent.debugInfo

  - Defined in ui/Base/BaseComponent.ts :41

  Return the debug info about this component.

  #### Returns any

### disable

- disable(): void

- Inherited from BaseComponent.disable

  - Defined in ui/Base/BaseComponent.ts :52

  Disable the component. Normally this means that the component will not execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### enable

- enable(): void

- Inherited from BaseComponent.enable

  - Defined in ui/Base/BaseComponent.ts :61

  Enable the component. Normally this means that the component will execute handlers for the framework events (query events, for example). Components are enabled by default on creation.

  #### Returns void

### getBindings

- getBindings(): IComponentBindings

- Inherited from Component.getBindings

  - Defined in ui/Base/Component.ts :328

  Return the bindings, or environment, for the current component.

  #### Returns IComponentBindings

### getCurrentCriteria

- getCurrentCriteria(): SortCriteria

- - Defined in ui/Sort/Sort.ts :189

  Gets the current `sortCriteria` of this `Sort` component.

  #### Returns SortCriteria

### match

- match(sortId: string): boolean

- - Defined in ui/Sort/Sort.ts :197

  Indicates whether the name of any of the available `sortCriteria` of this `Sort` component matches the argument.

  #### Parameters

  - ##### sortId: string

    The sort criteria name to look for (e.g., `date descending`).

  #### Returns boolean

### select

- select(direction?: string): void

- - Defined in ui/Sort/Sort.ts :147

  Selects this `Sort` component.

  Updates the state model if selecting this component toggles its current `sortCriteria`.

  #### Parameters

  - ##### Optional direction: string

    The sort direction. Can be one of: `ascending`, `descending`.

  #### Returns void

### selectAndExecuteQuery

- selectAndExecuteQuery(): void

- - Defined in ui/Sort/Sort.ts :166

  Selects this `Sort` component, then triggers a query if selecting this component toggles its current `sortCriteria`.

  Also logs an event in the usage analytics with the new current sort criteria.

  #### Returns void

### Static get

- get(element: HTMLElement, componentClass?: any, noThrow?: boolean): BaseComponent

- Inherited from Component.get

  - Defined in ui/Base/Component.ts :410

  Get the bound component to the given HTMLElement. Throws an assert if the HTMLElement has no component bound, unless using the noThrow argument.
  If there is multiple component bound to the current HTMLElement, you must specify the component class.

  #### Parameters

  - ##### element: HTMLElement

    HTMLElement for which to get the bound component.

  - ##### Optional componentClass: any

    Optional component class. If the HTMLElement has multiple components bound, you must specify which one you are targeting.

  - ##### Optional noThrow: boolean

    Boolean option to tell the method to not throw on error.

  #### Returns BaseComponent

## Properties

### bind

bind: ComponentEvents

Inherited from Component.bind

- Defined in ui/Base/Component.ts :270

Allows the component to bind events and execute them only when it is enabled.

type

  {Coveo.ComponentEvents}

### componentOptionsModel

componentOptionsModel: ComponentOptionsModel

Inherited from Component.componentOptionsModel

- Defined in ui/Base/Component.ts :294

Contains the state of options for different components. Mainly used by ResultLink.

### componentStateModel

componentStateModel: ComponentStateModel

Inherited from Component.componentStateModel

- Defined in ui/Base/Component.ts :282

Contains the state of different components (enabled vs disabled). Allows to get/set values. Triggers component state event when modified. Each component can listen to those events.

### disabled

disabled: boolean

Inherited from BaseComponent.disabled

- Defined in ui/Base/BaseComponent.ts :23

A disabled component will not participate in the query, or listen to ComponentEvents.

type

  {boolean}

### logger

logger: Logger

Inherited from BaseComponent.logger

- Defined in ui/Base/BaseComponent.ts :18

Allows component to log in the dev console.

### queryController

queryController: QueryController

Inherited from Component.queryController

- Defined in ui/Base/Component.ts :286

Contains the singleton that allows to trigger queries.

### queryStateModel

queryStateModel: QueryStateModel

Inherited from Component.queryStateModel

- Defined in ui/Base/Component.ts :278

Contains the state of the query. Allows to get/set values. Trigger query state event when modified. Each component can listen to those events.

### root

root: HTMLElement

Inherited from Component.root

- Defined in ui/Base/Component.ts :274

A reference to the root HTMLElement (the SearchInterface).

### searchInterface

searchInterface: SearchInterface

Inherited from Component.searchInterface

- Defined in ui/Base/Component.ts :290

A reference to the root of every component, the SearchInterface.

### Static ID

ID: string

Inherited from BaseComponent.ID

- Defined in ui/Base/BaseComponent.ts :28

The static ID that each component needs in order to be identified.
For example, SearchButton -> static ID: SearchButton -> className: CoveoSearchButton

## Accessors

### usageAnalytics

- get (): IAnalyticsClient

- Inherited from Component.usageAnalytics

  - Defined in ui/Base/Component.ts :343

  A reference to the Analytics.client.

  #### Returns IAnalyticsClient

## Component Options

### caption

caption: string

- Defined in ui/Sort/Sort.ts :95

The caption to display on this component instance.

By default, the component uses the text content of the element it is instanciated on.

Required

  Specifying a value for this option is required for the component to work

Markup configuration example(s) :

    data-caption='foo'

### sortCriteria

sortCriteria: SortCriteria[]

- Defined in ui/Sort/Sort.ts :76

The sort criterion/criteria the end user can select/toggle between when interacting with this component instance.

The available sort criteria are:

- `relevancy`
- `date ascending`/`date descending`
- `qre`
- `@field ascending`/`@field descending`, where you must replace `field` with the name of a sortable field in your index (e.g., `data-sort-criteria="@size ascending"`).

You can specify a comma separated list of sort criteria to toggle between when interacting with this component instance (e.g., `data-sort-criteria="date descending,date ascending"`).

You can specify multiple sort criteria to be used in the same request by separating them with a semicolon. For example, `data-sort-criteria="@size ascending;date ascending"`. However, this only works when combining: a relevancy criterion followed by one or more field or date criteria (e.g., `data-sort-criteria="relevancy; @length descending"`). a qre criterion followed by one or more field or date criteria (e.g., `data-sort-criteria="qre; @length descending"`). two or more field criteria (e.g., `data-sort-criteria="@size descending; @length ascending"`). a single date criterion and one or more field criteria in any order (e.g., `data-sort-criteria="@size descending; date ascending"`).

Interacting with this component instance will cycle through those criteria in the order they are listed in. Typically, you should only specify a list of sort criteria when you want the end user to be able to to toggle the direction of a `date` or `@field` sort criteria. Otherwise, you should configure a distinct `Sort` component instance for each sort criterion you want to make available in your search page.

You must specify a valid value for this option in order for this component instance to work correctly.

Examples:

- `data-sort-criteria="date ascending"` createes a Sort component that allows to sort on `date ascending`, without being able to toggle the order.
- `data-sort-criteria="date ascending, date descending"` creates a Sort component that allows end users to toggle between `date ascending` and `date descending` on click.
- `data-sort-criteria="@size ascending; date descending"` creates a Sort component that only allows end users to sort on `@size ascending`. The index then applies a second sort on `date descending` when two items are of equal value.
- `data-sort-criteria="@size ascending; date descending, @size descending; date descending"` creates a Sort component that allows end users to toggle between `@size ascending` and `@size descending`. For each value, the index applies a second sort on `date descending` when two items are of equal value.

Required

  Specifying a value for this option is required for the component to work

## Constructors

### constructor

- new Sort(element: HTMLElement, options?: ISortOptions, bindings?: IComponentBindings): Sort

- Overwrites Component.constructor

  - Defined in ui/Sort/Sort.ts :102

  Creates a new `Sort` component instance.

  #### Parameters

  - ##### element: HTMLElement

    The HTMLElement on which to instantiate the component.

  - ##### Optional options: ISortOptions

    The options for this component instance.

  - ##### Optional bindings: IComponentBindings

    The bindings that the component requires to function normally. If not set, these will be automatically resolved (with a slower execution time).

  #### Returns Sort